// Use "make example" to compile and run this example program

// Compile in both assertion and report testing.  I normally do this
// using the gcc compiler switch -DAPD_DEBUG_COMPILE
#define APD_DEBUG_COMPILE

// Now that any preprocessor settings have been made, we can load apd.h
#include <apd.h>

// Call the recursive function 25 levels deep
#define TEST_LEVELS 25

// ========================================
// ========================================
// Adjust report threshold up by two.  In this case, the report threshold
// set in apd_initialize() is 3, so the report threshold for this function
// will be 5, and the function description will print.
#undef APD_ADJUST_REPORT_THRESHOLD
#define APD_ADJUST_REPORT_THRESHOLD 2
void call_recurse(int level)
{
APD_PUSH_FUNCTION(5, "level=%d", level);
if (level == 10) APD_REPORT(5, "Extra message at level 10 before recursion");
if (level > 1) call_recurse(level-1);
if (level == 10) APD_REPORT(5, "Extra message at level 10 after recursion");
APD_POP_FUNCTION();
} // end call_recurse()
// Go back to just using the runtime threshold
// Note that you can't just #undef APD_ADJUST_REPORT_THRESHOLD,
// you have to also redefine it to 0, since it used internally in an addition.
#undef APD_ADJUST_REPORT_THRESHOLD
#define APD_ADJUST_REPORT_THRESHOLD 0

// ========================================
// ========================================
int main(void)
{
apd_object = apd_initialize(
    3,              /* int report_threshold */
    3,              /* int assert_threshold */
    TEST_LEVELS+1,  /* int max_function_depth */
    false,          /* report_threshold_decreases_with_stack */
    stdout          /* FILE *error_stream */
    );

APD_PUSH_FUNCTION(3);

// Test function tracking with a recursive function TEST_LEVELS deep.
call_recurse(TEST_LEVELS);

APD_REPORT_ACTION(3,
      printf("This is a report from APD_REPORT_ACTION(3, ...)\n");
      );

APD_POP_FUNCTION();
apd_end(&apd_object);
return(EXIT_SUCCESS);
} // end main()

